# abstract class OpenSSL::SSL::Socket

- OpenSSL::SSL::Socket
- IO
- Reference
- Object

##
Included Modules

- IO::Buffered

##
Direct Known Subclasses

- OpenSSL::SSL::Socket::Client
- OpenSSL::SSL::Socket::Server

##
Defined in:

##
Instance Method Summary

- #alpn_protocol

  Returns the negotiated ALPN protocol (eg: `"h2"`) of `nil` if no protocol was negotiated.

- #cipher : String

  Returns the current cipher used by this socket.

- #closed? : Bool

  Returns `true` if this `IO` is closed.

- #finalize
- #hostname : String?

  Returns the hostname provided through Server Name Indication (SNI)

- #local_address
- #read_timeout
- #read_timeout=(value)
- #remote_address
- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this socket will close the underlying IO.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this socket will close the underlying IO.

- #tls_version : String

  Returns the name of the TLS protocol version used by this socket.

- #unbuffered_close

  Closes the wrapped `IO`.

- #unbuffered_flush

  Flushes the wrapped `IO`.

- #unbuffered_read(slice : Bytes)

  Reads at most slice.size bytes from the wrapped `IO` into slice.

- #unbuffered_rewind

  Rewinds the wrapped `IO`.

- #unbuffered_write(slice : Bytes)

  Writes at most slice.size bytes from slice into the wrapped `IO`.

- #write_timeout
- #write_timeout=(value)

### Instance methods inherited from module `IO::Buffered`

buffer_size buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush flush, peek : Bytes? peek, read(slice : Bytes) read, read_buffering=(read_buffering) read_buffering=, read_buffering? read_buffering?, rewind rewind, sync=(sync) sync=, sync? sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : _) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : _) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def alpn_protocol #

Returns the negotiated ALPN protocol (eg: `"h2"`) of `nil` if no protocol was negotiated.

def cipher : String #

Returns the current cipher used by this socket.

def closed? : Bool #
Description copied from class IO

Returns `true` if this `IO` is closed.

`IO` defines returns `false`, but including types may override.

def finalize #
def hostname : String? #

Returns the hostname provided through Server Name Indication (SNI)

def local_address #
def read_timeout #
def read_timeout=(value) #
def remote_address #
def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this socket will close the underlying IO.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this socket will close the underlying IO.

def tls_version : String #

Returns the name of the TLS protocol version used by this socket.

def unbuffered_close #
Description copied from module IO::Buffered

Closes the wrapped `IO`.

def unbuffered_flush #
Description copied from module IO::Buffered

Flushes the wrapped `IO`.

def unbuffered_read(slice : Bytes) #
Description copied from module IO::Buffered

Reads at most slice.size bytes from the wrapped `IO` into slice. Returns the number of bytes read.

def unbuffered_rewind #
Description copied from module IO::Buffered

Rewinds the wrapped `IO`.

def unbuffered_write(slice : Bytes) #
Description copied from module IO::Buffered

Writes at most slice.size bytes from slice into the wrapped `IO`. Returns the number of bytes written.

def write_timeout #
def write_timeout=(value) #